# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from jsk_recognition_msgs/ExifGPSInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ExifGPSInfo(genpy.Message):
  _md5sum = "4d78b4fbebd5b498dabfce0a45f72762"
  _type = "jsk_recognition_msgs/ExifGPSInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """#
# https://exiftool.org/TagNames/GPS.html
#
# Tag ID	Tag Name	Writable	Values / Notes
# 0x0000	GPSVersionID	int8u[4]:
uint8[4] gps_version_id
# 0x0001	GPSLatitudeRef	string[2]	(tags 0x0001-0x0006 used for camera location according to MWG 2.0. ExifTool will also accept a number when writing GPSLatitudeRef, positive for north latitudes or negative for south, or a string containing N, North, S or South)
# 						'N' = North
# 						'S' = South
string gps_latitude_ref
# 0x0002	GPSLatitude	rational64u[3]
float64[3] gps_latitude
# 0x0003	GPSLongitudeRef	string[2]	(ExifTool will also accept a number when writing this tag, positive for east longitudes or negative for west, or a string containing E, East, W or West)
# 						'E' = East
# 						'W' = West
string gps_longitude_ref
# 0x0004	GPSLongitude	rational64u[3]
float64[3] gps_longitude
# 0x0005	GPSAltitudeRef	int8u	(ExifTool will also accept number when writing this tag, with negative numbers indicating below sea level)
uint8 gps_altitude_ref
# 						0 = Above Sea Level
# 						1 = Below Sea Level
# 0x0006	GPSAltitude	rational64u
float64 gps_altitude
# 0x0007	GPSTimeStamp	rational64u[3]	(UTC time of GPS fix. When writing, date is stripped off if present, and time is adjusted to UTC if it includes a timezone)
float64 gps_time_stamp
# 0x0008	GPSSatellites	string
string gps_satellites
# 0x0009	GPSStatus	string[2]
# 						'A' = Measurement Active
# 						'V' = Measurement Void
string gps_status
# 0x000a	GPSMeasureMode	string[2]
# 						2 = 2-Dimensional Measurement
# 						3 = 3-Dimensional Measurement
string gps_measure_mode
# 0x000b	GPSDOP	rational64u
float64 gpf_sdop
# 0x000c	GPSSpeedRef	string[2]
# 						'K' = km/h
# 						'M' = mph
# 						'N' = knots
string gps_speed_ref
# 0x000d	GPSSpeed	rational64u
float64 gps_speed
# 0x000e	GPSTrackRef	string[2]
# 						'M' = Magnetic North
# 						'T' = True North
string gps_track_ref
# 0x000f	GPSTrack	rational64u
float64 gps_track
# 0x0010	GPSImgDirectionRef	string[2]
# 						'M' = Magnetic North
# 						'T' = True North
string gps_img_direction_ref
# 0x0011	GPSImgDirection	rational64u
float64 gps_img_direction
# 0x0012	GPSMapDatum	string
string gps_map_datum
# 0x0013	GPSDestLatitudeRef	string[2]	(tags 0x0013-0x001a used for subject location according to MWG 2.0)
# 						'N' = North
# 						'S' = South
string gps_dest_latitude_ref
# 0x0014	GPSDestLatitude	rational64u[3]
float64[3] gps_dest_latitude
# 0x0015	GPSDestLongitudeRef	string[2]
# 						'E' = East
# 						'W' = West
string gps_dest_longitude_ref
# 0x0016	GPSDestLongitude	rational64u[3]
float64[3] gps_dest_longitude
# 0x0017	GPSDestBearingRef	string[2]
# 						'M' = Magnetic North
# 						'T' = True North
string gps_dest_bearing_ref
# 0x0018	GPSDestBearing	rational64u
float64 gps_dest_bearing
# 0x0019	GPSDestDistanceRef	string[2]
# 						'K' = Kilometers
# 						'M' = Miles
# 						'N' = Nautical Miles
string gps_dest_distance_ref
# 0x001a	GPSDestDistance	rational64u
float64 gps_dest_distance
# 0x001b	GPSProcessingMethod	undef	(values of "GPS", "CELLID", "WLAN" or "MANUAL" by the EXIF spec.)
# 0x001c	GPSAreaInformation	undef
# 0x001d	GPSDateStamp	string[11]	(when writing, time is stripped off if present, after adjusting date/time to UTC if time includes a timezone. Format is YYYY:mm:dd)
string gps_date_stamp
# 0x001e	GPSDifferential	int16u
# 						0 = No Correction
# 						1 = Differential Corrected
uint16 gps_differential
# 0x001f	GPSHPositioningError	rational64u
float64 gps_hpositioning_error

"""
  __slots__ = ['gps_version_id','gps_latitude_ref','gps_latitude','gps_longitude_ref','gps_longitude','gps_altitude_ref','gps_altitude','gps_time_stamp','gps_satellites','gps_status','gps_measure_mode','gpf_sdop','gps_speed_ref','gps_speed','gps_track_ref','gps_track','gps_img_direction_ref','gps_img_direction','gps_map_datum','gps_dest_latitude_ref','gps_dest_latitude','gps_dest_longitude_ref','gps_dest_longitude','gps_dest_bearing_ref','gps_dest_bearing','gps_dest_distance_ref','gps_dest_distance','gps_date_stamp','gps_differential','gps_hpositioning_error']
  _slot_types = ['uint8[4]','string','float64[3]','string','float64[3]','uint8','float64','float64','string','string','string','float64','string','float64','string','float64','string','float64','string','string','float64[3]','string','float64[3]','string','float64','string','float64','string','uint16','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       gps_version_id,gps_latitude_ref,gps_latitude,gps_longitude_ref,gps_longitude,gps_altitude_ref,gps_altitude,gps_time_stamp,gps_satellites,gps_status,gps_measure_mode,gpf_sdop,gps_speed_ref,gps_speed,gps_track_ref,gps_track,gps_img_direction_ref,gps_img_direction,gps_map_datum,gps_dest_latitude_ref,gps_dest_latitude,gps_dest_longitude_ref,gps_dest_longitude,gps_dest_bearing_ref,gps_dest_bearing,gps_dest_distance_ref,gps_dest_distance,gps_date_stamp,gps_differential,gps_hpositioning_error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ExifGPSInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.gps_version_id is None:
        self.gps_version_id = b'\0'*4
      if self.gps_latitude_ref is None:
        self.gps_latitude_ref = ''
      if self.gps_latitude is None:
        self.gps_latitude = [0.] * 3
      if self.gps_longitude_ref is None:
        self.gps_longitude_ref = ''
      if self.gps_longitude is None:
        self.gps_longitude = [0.] * 3
      if self.gps_altitude_ref is None:
        self.gps_altitude_ref = 0
      if self.gps_altitude is None:
        self.gps_altitude = 0.
      if self.gps_time_stamp is None:
        self.gps_time_stamp = 0.
      if self.gps_satellites is None:
        self.gps_satellites = ''
      if self.gps_status is None:
        self.gps_status = ''
      if self.gps_measure_mode is None:
        self.gps_measure_mode = ''
      if self.gpf_sdop is None:
        self.gpf_sdop = 0.
      if self.gps_speed_ref is None:
        self.gps_speed_ref = ''
      if self.gps_speed is None:
        self.gps_speed = 0.
      if self.gps_track_ref is None:
        self.gps_track_ref = ''
      if self.gps_track is None:
        self.gps_track = 0.
      if self.gps_img_direction_ref is None:
        self.gps_img_direction_ref = ''
      if self.gps_img_direction is None:
        self.gps_img_direction = 0.
      if self.gps_map_datum is None:
        self.gps_map_datum = ''
      if self.gps_dest_latitude_ref is None:
        self.gps_dest_latitude_ref = ''
      if self.gps_dest_latitude is None:
        self.gps_dest_latitude = [0.] * 3
      if self.gps_dest_longitude_ref is None:
        self.gps_dest_longitude_ref = ''
      if self.gps_dest_longitude is None:
        self.gps_dest_longitude = [0.] * 3
      if self.gps_dest_bearing_ref is None:
        self.gps_dest_bearing_ref = ''
      if self.gps_dest_bearing is None:
        self.gps_dest_bearing = 0.
      if self.gps_dest_distance_ref is None:
        self.gps_dest_distance_ref = ''
      if self.gps_dest_distance is None:
        self.gps_dest_distance = 0.
      if self.gps_date_stamp is None:
        self.gps_date_stamp = ''
      if self.gps_differential is None:
        self.gps_differential = 0
      if self.gps_hpositioning_error is None:
        self.gps_hpositioning_error = 0.
    else:
      self.gps_version_id = b'\0'*4
      self.gps_latitude_ref = ''
      self.gps_latitude = [0.] * 3
      self.gps_longitude_ref = ''
      self.gps_longitude = [0.] * 3
      self.gps_altitude_ref = 0
      self.gps_altitude = 0.
      self.gps_time_stamp = 0.
      self.gps_satellites = ''
      self.gps_status = ''
      self.gps_measure_mode = ''
      self.gpf_sdop = 0.
      self.gps_speed_ref = ''
      self.gps_speed = 0.
      self.gps_track_ref = ''
      self.gps_track = 0.
      self.gps_img_direction_ref = ''
      self.gps_img_direction = 0.
      self.gps_map_datum = ''
      self.gps_dest_latitude_ref = ''
      self.gps_dest_latitude = [0.] * 3
      self.gps_dest_longitude_ref = ''
      self.gps_dest_longitude = [0.] * 3
      self.gps_dest_bearing_ref = ''
      self.gps_dest_bearing = 0.
      self.gps_dest_distance_ref = ''
      self.gps_dest_distance = 0.
      self.gps_date_stamp = ''
      self.gps_differential = 0
      self.gps_hpositioning_error = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.gps_version_id
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_4B().pack(*_x))
      else:
        buff.write(_get_struct_4s().pack(_x))
      _x = self.gps_latitude_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(_get_struct_3d().pack(*self.gps_latitude))
      _x = self.gps_longitude_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(_get_struct_3d().pack(*self.gps_longitude))
      _x = self
      buff.write(_get_struct_B2d().pack(_x.gps_altitude_ref, _x.gps_altitude, _x.gps_time_stamp))
      _x = self.gps_satellites
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_status
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_measure_mode
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gpf_sdop
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_speed_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_speed
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_track_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_track
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_img_direction_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_img_direction
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_map_datum
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_dest_latitude_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(_get_struct_3d().pack(*self.gps_dest_latitude))
      _x = self.gps_dest_longitude_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(_get_struct_3d().pack(*self.gps_dest_longitude))
      _x = self.gps_dest_bearing_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_dest_bearing
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_dest_distance_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_dest_distance
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_date_stamp
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Hd().pack(_x.gps_differential, _x.gps_hpositioning_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      self.gps_version_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_latitude_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_latitude_ref = str[start:end]
      start = end
      end += 24
      self.gps_latitude = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_longitude_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_longitude_ref = str[start:end]
      start = end
      end += 24
      self.gps_longitude = _get_struct_3d().unpack(str[start:end])
      _x = self
      start = end
      end += 17
      (_x.gps_altitude_ref, _x.gps_altitude, _x.gps_time_stamp,) = _get_struct_B2d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_satellites = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_satellites = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_status = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_status = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_measure_mode = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_measure_mode = str[start:end]
      start = end
      end += 8
      (self.gpf_sdop,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_speed_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_speed_ref = str[start:end]
      start = end
      end += 8
      (self.gps_speed,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_track_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_track_ref = str[start:end]
      start = end
      end += 8
      (self.gps_track,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_img_direction_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_img_direction_ref = str[start:end]
      start = end
      end += 8
      (self.gps_img_direction,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_map_datum = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_map_datum = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_dest_latitude_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_dest_latitude_ref = str[start:end]
      start = end
      end += 24
      self.gps_dest_latitude = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_dest_longitude_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_dest_longitude_ref = str[start:end]
      start = end
      end += 24
      self.gps_dest_longitude = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_dest_bearing_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_dest_bearing_ref = str[start:end]
      start = end
      end += 8
      (self.gps_dest_bearing,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_dest_distance_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_dest_distance_ref = str[start:end]
      start = end
      end += 8
      (self.gps_dest_distance,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_date_stamp = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_date_stamp = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.gps_differential, _x.gps_hpositioning_error,) = _get_struct_Hd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.gps_version_id
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(_get_struct_4B().pack(*_x))
      else:
        buff.write(_get_struct_4s().pack(_x))
      _x = self.gps_latitude_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(self.gps_latitude.tostring())
      _x = self.gps_longitude_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(self.gps_longitude.tostring())
      _x = self
      buff.write(_get_struct_B2d().pack(_x.gps_altitude_ref, _x.gps_altitude, _x.gps_time_stamp))
      _x = self.gps_satellites
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_status
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_measure_mode
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gpf_sdop
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_speed_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_speed
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_track_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_track
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_img_direction_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_img_direction
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_map_datum
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_dest_latitude_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(self.gps_dest_latitude.tostring())
      _x = self.gps_dest_longitude_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      buff.write(self.gps_dest_longitude.tostring())
      _x = self.gps_dest_bearing_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_dest_bearing
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_dest_distance_ref
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.gps_dest_distance
      buff.write(_get_struct_d().pack(_x))
      _x = self.gps_date_stamp
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_Hd().pack(_x.gps_differential, _x.gps_hpositioning_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      self.gps_version_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_latitude_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_latitude_ref = str[start:end]
      start = end
      end += 24
      self.gps_latitude = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_longitude_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_longitude_ref = str[start:end]
      start = end
      end += 24
      self.gps_longitude = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      _x = self
      start = end
      end += 17
      (_x.gps_altitude_ref, _x.gps_altitude, _x.gps_time_stamp,) = _get_struct_B2d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_satellites = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_satellites = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_status = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_status = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_measure_mode = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_measure_mode = str[start:end]
      start = end
      end += 8
      (self.gpf_sdop,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_speed_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_speed_ref = str[start:end]
      start = end
      end += 8
      (self.gps_speed,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_track_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_track_ref = str[start:end]
      start = end
      end += 8
      (self.gps_track,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_img_direction_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_img_direction_ref = str[start:end]
      start = end
      end += 8
      (self.gps_img_direction,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_map_datum = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_map_datum = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_dest_latitude_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_dest_latitude_ref = str[start:end]
      start = end
      end += 24
      self.gps_dest_latitude = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_dest_longitude_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_dest_longitude_ref = str[start:end]
      start = end
      end += 24
      self.gps_dest_longitude = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=3)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_dest_bearing_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_dest_bearing_ref = str[start:end]
      start = end
      end += 8
      (self.gps_dest_bearing,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_dest_distance_ref = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_dest_distance_ref = str[start:end]
      start = end
      end += 8
      (self.gps_dest_distance,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.gps_date_stamp = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.gps_date_stamp = str[start:end]
      _x = self
      start = end
      end += 10
      (_x.gps_differential, _x.gps_hpositioning_error,) = _get_struct_Hd().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
_struct_4s = None
def _get_struct_4s():
    global _struct_4s
    if _struct_4s is None:
        _struct_4s = struct.Struct("<4s")
    return _struct_4s
_struct_B2d = None
def _get_struct_B2d():
    global _struct_B2d
    if _struct_B2d is None:
        _struct_B2d = struct.Struct("<B2d")
    return _struct_B2d
_struct_Hd = None
def _get_struct_Hd():
    global _struct_Hd
    if _struct_Hd is None:
        _struct_Hd = struct.Struct("<Hd")
    return _struct_Hd
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
