# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from jsk_recognition_msgs/PanoramaInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class PanoramaInfo(genpy.Message):
  _md5sum = "340435d77351bcae6fd5d846323c4a05"
  _type = "jsk_recognition_msgs/PanoramaInfo"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# This message defines meta information for a panorama image.

#######################################################################
#                     Image acquisition info                          #
#######################################################################
std_msgs/Header header

#######################################################################
#                      Image projection info                          #
#######################################################################
string projection_model

#######################################################################
#                      Image shape info                               #
#######################################################################
uint32 image_height
uint32 image_width

#######################################################################
#                     Field of View Parameters                        #
#######################################################################
float64 theta_min
float64 theta_max
float64 phi_min
float64 phi_max

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','projection_model','image_height','image_width','theta_min','theta_max','phi_min','phi_max']
  _slot_types = ['std_msgs/Header','string','uint32','uint32','float64','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,projection_model,image_height,image_width,theta_min,theta_max,phi_min,phi_max

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PanoramaInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.projection_model is None:
        self.projection_model = ''
      if self.image_height is None:
        self.image_height = 0
      if self.image_width is None:
        self.image_width = 0
      if self.theta_min is None:
        self.theta_min = 0.
      if self.theta_max is None:
        self.theta_max = 0.
      if self.phi_min is None:
        self.phi_min = 0.
      if self.phi_max is None:
        self.phi_max = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.projection_model = ''
      self.image_height = 0
      self.image_width = 0
      self.theta_min = 0.
      self.theta_max = 0.
      self.phi_min = 0.
      self.phi_max = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.projection_model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I4d().pack(_x.image_height, _x.image_width, _x.theta_min, _x.theta_max, _x.phi_min, _x.phi_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.projection_model = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.projection_model = str[start:end]
      _x = self
      start = end
      end += 40
      (_x.image_height, _x.image_width, _x.theta_min, _x.theta_max, _x.phi_min, _x.phi_max,) = _get_struct_2I4d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.projection_model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I4d().pack(_x.image_height, _x.image_width, _x.theta_min, _x.theta_max, _x.phi_min, _x.phi_max))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.projection_model = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.projection_model = str[start:end]
      _x = self
      start = end
      end += 40
      (_x.image_height, _x.image_width, _x.theta_min, _x.theta_max, _x.phi_min, _x.phi_max,) = _get_struct_2I4d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I4d = None
def _get_struct_2I4d():
    global _struct_2I4d
    if _struct_2I4d is None:
        _struct_2I4d = struct.Struct("<2I4d")
    return _struct_2I4d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
